Index: /XIOS/trunk/src/interface/fortran/ixml_tree.F90
===================================================================
--- /XIOS/trunk/src/interface/fortran/ixml_tree.F90	(revision 471)
+++ /XIOS/trunk/src/interface/fortran/ixml_tree.F90	(revision 472)
@@ -8,4 +8,5 @@
    USE IGRID
    USE IDOMAIN
+   USE IVARIABLE
      
    INTERFACE ! Ne pas appeler directement/Interface FORTRAN 2003 <-> C99
@@ -59,4 +60,22 @@
       END SUBROUTINE cxios_xml_tree_add_fieldtofile
 
+      SUBROUTINE cxios_xml_tree_add_variabletofile(parent_, child_, child_id, child_id_size) BIND(C)
+         USE ISO_C_BINDING
+         INTEGER  (kind = C_INTPTR_T), VALUE        :: parent_
+         INTEGER  (kind = C_INTPTR_T)               :: child_
+         CHARACTER(kind = C_CHAR)    , DIMENSION(*) :: child_id
+         INTEGER  (kind = C_INT)     , VALUE        :: child_id_size
+      END SUBROUTINE cxios_xml_tree_add_variabletofile
+
+
+      SUBROUTINE cxios_xml_tree_add_variabletofield(parent_, child_, child_id, child_id_size) BIND(C)
+         USE ISO_C_BINDING
+         INTEGER  (kind = C_INTPTR_T), VALUE        :: parent_
+         INTEGER  (kind = C_INTPTR_T)               :: child_
+         CHARACTER(kind = C_CHAR)    , DIMENSION(*) :: child_id
+         INTEGER  (kind = C_INT)     , VALUE        :: child_id_size
+      END SUBROUTINE cxios_xml_tree_add_variabletofield
+
+
       SUBROUTINE cxios_xml_tree_add_fieldgroup(parent_, child_, child_id, child_id_size) BIND(C)
          USE ISO_C_BINDING
@@ -106,4 +125,20 @@
          INTEGER  (kind = C_INT)     , VALUE        :: child_id_size
       END SUBROUTINE cxios_xml_tree_add_fieldgrouptofile    
+
+      SUBROUTINE cxios_xml_tree_add_variablegrouptofile(parent_, child_, child_id, child_id_size) BIND(C)
+         USE ISO_C_BINDING
+         INTEGER  (kind = C_INTPTR_T), VALUE        :: parent_
+         INTEGER  (kind = C_INTPTR_T)               :: child_
+         CHARACTER(kind = C_CHAR)    , DIMENSION(*) :: child_id
+         INTEGER  (kind = C_INT)     , VALUE        :: child_id_size
+      END SUBROUTINE cxios_xml_tree_add_variablegrouptofile    
+
+      SUBROUTINE cxios_xml_tree_add_variablegrouptofield(parent_, child_, child_id, child_id_size) BIND(C)
+         USE ISO_C_BINDING
+         INTEGER  (kind = C_INTPTR_T), VALUE        :: parent_
+         INTEGER  (kind = C_INTPTR_T)               :: child_
+         CHARACTER(kind = C_CHAR)    , DIMENSION(*) :: child_id
+         INTEGER  (kind = C_INT)     , VALUE        :: child_id_size
+      END SUBROUTINE cxios_xml_tree_add_variablegrouptofield    
 
       SUBROUTINE cxios_xml_tree_show(filename, filename_size) BIND(C)
@@ -210,4 +245,30 @@
    END SUBROUTINE xios(add_fieldtofile)
 
+   SUBROUTINE xios(add_variabletofile)(parent_hdl, child_hdl, child_id)
+      TYPE(txios(file))            , INTENT(IN) :: parent_hdl
+      TYPE(txios(variable))           , INTENT(OUT):: child_hdl
+      CHARACTER(len = *), OPTIONAL , INTENT(IN) :: child_id
+
+      IF (PRESENT(child_id)) THEN
+         CALL cxios_xml_tree_add_variabletofile(parent_hdl%daddr, child_hdl%daddr, child_id, len(child_id))
+      ELSE
+         CALL cxios_xml_tree_add_variabletofile(parent_hdl%daddr, child_hdl%daddr, "NONE", -1)
+      END IF
+
+   END SUBROUTINE xios(add_variabletofile)
+
+   SUBROUTINE xios(add_variabletofield)(parent_hdl, child_hdl, child_id)
+      TYPE(txios(field))            , INTENT(IN) :: parent_hdl
+      TYPE(txios(variable))           , INTENT(OUT):: child_hdl
+      CHARACTER(len = *), OPTIONAL , INTENT(IN) :: child_id
+
+      IF (PRESENT(child_id)) THEN
+         CALL cxios_xml_tree_add_variabletofield(parent_hdl%daddr, child_hdl%daddr, child_id, len(child_id))
+      ELSE
+         CALL cxios_xml_tree_add_variabletofield(parent_hdl%daddr, child_hdl%daddr, "NONE", -1)
+      END IF
+
+   END SUBROUTINE xios(add_variabletofield)
+
 
    SUBROUTINE xios(add_axisgroup)(parent_hdl, child_hdl, child_id)
@@ -288,4 +349,30 @@
 
    END SUBROUTINE xios(add_fieldgrouptofile)
-      
+
+   SUBROUTINE xios(add_variablegrouptofile)(parent_hdl, child_hdl, child_id)
+      TYPE(txios(file))            , INTENT(IN) :: parent_hdl
+      TYPE(txios(variablegroup))     , INTENT(OUT):: child_hdl
+      CHARACTER(len = *), OPTIONAL  , INTENT(IN) :: child_id
+
+      IF (PRESENT(child_id)) THEN
+         CALL cxios_xml_tree_add_variablegrouptofile(parent_hdl%daddr, child_hdl%daddr, child_id, len(child_id))
+      ELSE
+         CALL cxios_xml_tree_add_variablegrouptofile(parent_hdl%daddr, child_hdl%daddr, "NONE", -1)
+      END IF
+
+   END SUBROUTINE xios(add_variablegrouptofile)
+
+   SUBROUTINE xios(add_variablegrouptofield)(parent_hdl, child_hdl, child_id)
+      TYPE(txios(field))            , INTENT(IN) :: parent_hdl
+      TYPE(txios(variablegroup))     , INTENT(OUT):: child_hdl
+      CHARACTER(len = *), OPTIONAL  , INTENT(IN) :: child_id
+
+      IF (PRESENT(child_id)) THEN
+         CALL cxios_xml_tree_add_variablegrouptofield(parent_hdl%daddr, child_hdl%daddr, child_id, len(child_id))
+      ELSE
+         CALL cxios_xml_tree_add_variablegrouptofield(parent_hdl%daddr, child_hdl%daddr, "NONE", -1)
+      END IF
+
+   END SUBROUTINE xios(add_variablegrouptofield)  
+         
 END MODULE IXML_TREE
Index: /XIOS/trunk/src/interface/fortran/variable_interface.f90
===================================================================
--- /XIOS/trunk/src/interface/fortran/variable_interface.f90	(revision 472)
+++ /XIOS/trunk/src/interface/fortran/variable_interface.f90	(revision 472)
@@ -0,0 +1,22 @@
+MODULE VARIABLE_INTERFACE
+   USE, INTRINSIC :: ISO_C_BINDING
+     
+   INTERFACE ! Ne pas appeler directement/Interface FORTRAN 2003 <-> C99
+     
+      SUBROUTINE cxios_variable_handle_create(ret, idt, idt_size) BIND(C)
+         USE ISO_C_BINDING
+         INTEGER  (kind = C_INTPTR_T)               :: ret
+         CHARACTER(kind = C_CHAR)    , DIMENSION(*) :: idt
+         INTEGER  (kind = C_INT)     , VALUE        :: idt_size
+      END SUBROUTINE cxios_variable_handle_create
+
+      SUBROUTINE cxios_variable_valid_id(ret, idt, idt_size) BIND(C)
+         USE ISO_C_BINDING
+         LOGICAL  (kind = C_BOOL)                   :: ret
+         CHARACTER(kind = C_CHAR)    , DIMENSION(*) :: idt
+         INTEGER  (kind = C_INT)     , VALUE        :: idt_size
+      END SUBROUTINE cxios_variable_valid_id
+
+   END INTERFACE
+     
+END MODULE VARIABLE_INTERFACE
Index: /XIOS/trunk/src/interface/fortran/variablegroup_interface.f90
===================================================================
--- /XIOS/trunk/src/interface/fortran/variablegroup_interface.f90	(revision 472)
+++ /XIOS/trunk/src/interface/fortran/variablegroup_interface.f90	(revision 472)
@@ -0,0 +1,23 @@
+MODULE VARIABLEGROUP_INTERFACE
+   USE, INTRINSIC :: ISO_C_BINDING
+     
+   INTERFACE ! Ne pas appeler directement/Interface FORTRAN 2003 <-> C99
+     
+  
+      SUBROUTINE cxios_variablegroup_handle_create(ret, idt, idt_size) BIND(C)
+         USE ISO_C_BINDING
+         INTEGER  (kind = C_INTPTR_T)               :: ret
+         CHARACTER(kind = C_CHAR)    , DIMENSION(*) :: idt
+         INTEGER  (kind = C_INT)     , VALUE        :: idt_size
+      END SUBROUTINE cxios_variablegroup_handle_create
+
+      SUBROUTINE cxios_variablegroup_valid_id(ret, idt, idt_size) BIND(C)
+         USE ISO_C_BINDING
+         LOGICAL  (kind = C_BOOL)                   :: ret
+         CHARACTER(kind = C_CHAR)    , DIMENSION(*) :: idt
+         INTEGER  (kind = C_INT)     , VALUE        :: idt_size
+      END SUBROUTINE cxios_variablegroup_valid_id
+
+   END INTERFACE
+     
+END MODULE VARIABLEGROUP_INTERFACE
Index: /XIOS/trunk/src/interface/fortran_attr/field_interface_attr.f90
===================================================================
--- /XIOS/trunk/src/interface/fortran_attr/field_interface_attr.f90	(revision 471)
+++ /XIOS/trunk/src/interface/fortran_attr/field_interface_attr.f90	(revision 472)
@@ -68,4 +68,23 @@
     
     
+    SUBROUTINE cxios_set_field_detect_missing_value(field_hdl, detect_missing_value) BIND(C)
+      USE ISO_C_BINDING
+      INTEGER (kind = C_INTPTR_T), VALUE :: field_hdl
+      LOGICAL (KIND=C_BOOL)      , VALUE :: detect_missing_value
+    END SUBROUTINE cxios_set_field_detect_missing_value
+    
+    SUBROUTINE cxios_get_field_detect_missing_value(field_hdl, detect_missing_value) BIND(C)
+      USE ISO_C_BINDING
+      INTEGER (kind = C_INTPTR_T), VALUE :: field_hdl
+      LOGICAL (KIND=C_BOOL)             :: detect_missing_value
+    END SUBROUTINE cxios_get_field_detect_missing_value
+    
+    FUNCTION cxios_is_defined_field_detect_missing_value(field_hdl ) BIND(C)
+      USE ISO_C_BINDING
+      LOGICAL(kind=C_BOOL) :: cxios_is_defined_field_detect_missing_value
+      INTEGER (kind = C_INTPTR_T), VALUE :: field_hdl
+    END FUNCTION cxios_is_defined_field_detect_missing_value
+    
+    
     SUBROUTINE cxios_set_field_domain_ref(field_hdl, domain_ref, domain_ref_size) BIND(C)
       USE ISO_C_BINDING
Index: /XIOS/trunk/src/interface/fortran_attr/fieldgroup_interface_attr.f90
===================================================================
--- /XIOS/trunk/src/interface/fortran_attr/fieldgroup_interface_attr.f90	(revision 471)
+++ /XIOS/trunk/src/interface/fortran_attr/fieldgroup_interface_attr.f90	(revision 472)
@@ -68,4 +68,23 @@
     
     
+    SUBROUTINE cxios_set_fieldgroup_detect_missing_value(fieldgroup_hdl, detect_missing_value) BIND(C)
+      USE ISO_C_BINDING
+      INTEGER (kind = C_INTPTR_T), VALUE :: fieldgroup_hdl
+      LOGICAL (KIND=C_BOOL)      , VALUE :: detect_missing_value
+    END SUBROUTINE cxios_set_fieldgroup_detect_missing_value
+    
+    SUBROUTINE cxios_get_fieldgroup_detect_missing_value(fieldgroup_hdl, detect_missing_value) BIND(C)
+      USE ISO_C_BINDING
+      INTEGER (kind = C_INTPTR_T), VALUE :: fieldgroup_hdl
+      LOGICAL (KIND=C_BOOL)             :: detect_missing_value
+    END SUBROUTINE cxios_get_fieldgroup_detect_missing_value
+    
+    FUNCTION cxios_is_defined_fieldgroup_detect_missing_value(fieldgroup_hdl ) BIND(C)
+      USE ISO_C_BINDING
+      LOGICAL(kind=C_BOOL) :: cxios_is_defined_fieldgroup_detect_missing_value
+      INTEGER (kind = C_INTPTR_T), VALUE :: fieldgroup_hdl
+    END FUNCTION cxios_is_defined_fieldgroup_detect_missing_value
+    
+    
     SUBROUTINE cxios_set_fieldgroup_domain_ref(fieldgroup_hdl, domain_ref, domain_ref_size) BIND(C)
       USE ISO_C_BINDING
Index: /XIOS/trunk/src/interface/fortran_attr/ifield_attr.F90
===================================================================
--- /XIOS/trunk/src/interface/fortran_attr/ifield_attr.F90	(revision 471)
+++ /XIOS/trunk/src/interface/fortran_attr/ifield_attr.F90	(revision 472)
@@ -12,7 +12,7 @@
   
   SUBROUTINE xios(set_field_attr)  &
-    ( field_id, add_offset, axis_ref, default_value, domain_ref, enabled, field_ref, freq_offset  &
-    , freq_op, grid_ref, level, long_name, name, operation, prec, scale_factor, standard_name, unit  &
-    , valid_max, valid_min )
+    ( field_id, add_offset, axis_ref, default_value, detect_missing_value, domain_ref, enabled, field_ref  &
+    , freq_offset, freq_op, grid_ref, level, long_name, name, operation, prec, scale_factor, standard_name  &
+    , unit, valid_max, valid_min )
     
     IMPLICIT NONE
@@ -22,4 +22,6 @@
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: axis_ref
       REAL (KIND=8) , OPTIONAL, INTENT(IN) :: default_value
+      LOGICAL  , OPTIONAL, INTENT(IN) :: detect_missing_value
+      LOGICAL (KIND=C_BOOL) :: detect_missing_value_tmp
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: domain_ref
       LOGICAL  , OPTIONAL, INTENT(IN) :: enabled
@@ -42,14 +44,14 @@
       CALL xios(get_field_handle)(field_id,field_hdl)
       CALL xios(set_field_attr_hdl_)   &
-      ( field_hdl, add_offset, axis_ref, default_value, domain_ref, enabled, field_ref, freq_offset  &
-      , freq_op, grid_ref, level, long_name, name, operation, prec, scale_factor, standard_name, unit  &
-      , valid_max, valid_min )
+      ( field_hdl, add_offset, axis_ref, default_value, detect_missing_value, domain_ref, enabled  &
+      , field_ref, freq_offset, freq_op, grid_ref, level, long_name, name, operation, prec, scale_factor  &
+      , standard_name, unit, valid_max, valid_min )
     
   END SUBROUTINE xios(set_field_attr)
   
   SUBROUTINE xios(set_field_attr_hdl)  &
-    ( field_hdl, add_offset, axis_ref, default_value, domain_ref, enabled, field_ref, freq_offset  &
-    , freq_op, grid_ref, level, long_name, name, operation, prec, scale_factor, standard_name, unit  &
-    , valid_max, valid_min )
+    ( field_hdl, add_offset, axis_ref, default_value, detect_missing_value, domain_ref, enabled  &
+    , field_ref, freq_offset, freq_op, grid_ref, level, long_name, name, operation, prec, scale_factor  &
+    , standard_name, unit, valid_max, valid_min )
     
     IMPLICIT NONE
@@ -58,4 +60,6 @@
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: axis_ref
       REAL (KIND=8) , OPTIONAL, INTENT(IN) :: default_value
+      LOGICAL  , OPTIONAL, INTENT(IN) :: detect_missing_value
+      LOGICAL (KIND=C_BOOL) :: detect_missing_value_tmp
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: domain_ref
       LOGICAL  , OPTIONAL, INTENT(IN) :: enabled
@@ -77,14 +81,14 @@
       
       CALL xios(set_field_attr_hdl_)  &
-      ( field_hdl, add_offset, axis_ref, default_value, domain_ref, enabled, field_ref, freq_offset  &
-      , freq_op, grid_ref, level, long_name, name, operation, prec, scale_factor, standard_name, unit  &
-      , valid_max, valid_min )
+      ( field_hdl, add_offset, axis_ref, default_value, detect_missing_value, domain_ref, enabled  &
+      , field_ref, freq_offset, freq_op, grid_ref, level, long_name, name, operation, prec, scale_factor  &
+      , standard_name, unit, valid_max, valid_min )
     
   END SUBROUTINE xios(set_field_attr_hdl)
   
   SUBROUTINE xios(set_field_attr_hdl_)   &
-    ( field_hdl, add_offset_, axis_ref_, default_value_, domain_ref_, enabled_, field_ref_, freq_offset_  &
-    , freq_op_, grid_ref_, level_, long_name_, name_, operation_, prec_, scale_factor_, standard_name_  &
-    , unit_, valid_max_, valid_min_ )
+    ( field_hdl, add_offset_, axis_ref_, default_value_, detect_missing_value_, domain_ref_, enabled_  &
+    , field_ref_, freq_offset_, freq_op_, grid_ref_, level_, long_name_, name_, operation_, prec_  &
+    , scale_factor_, standard_name_, unit_, valid_max_, valid_min_ )
     
     IMPLICIT NONE
@@ -93,4 +97,6 @@
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: axis_ref_
       REAL (KIND=8) , OPTIONAL, INTENT(IN) :: default_value_
+      LOGICAL  , OPTIONAL, INTENT(IN) :: detect_missing_value_
+      LOGICAL (KIND=C_BOOL) :: detect_missing_value__tmp
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: domain_ref_
       LOGICAL  , OPTIONAL, INTENT(IN) :: enabled_
@@ -123,4 +129,9 @@
       ENDIF
       
+      IF (PRESENT(detect_missing_value_)) THEN
+        detect_missing_value__tmp=detect_missing_value_
+        CALL cxios_set_field_detect_missing_value(field_hdl%daddr, detect_missing_value__tmp)
+      ENDIF
+      
       IF (PRESENT(domain_ref_)) THEN
         CALL cxios_set_field_domain_ref(field_hdl%daddr, domain_ref_, len(domain_ref_))
@@ -193,7 +204,7 @@
   
   SUBROUTINE xios(get_field_attr)  &
-    ( field_id, add_offset, axis_ref, default_value, domain_ref, enabled, field_ref, freq_offset  &
-    , freq_op, grid_ref, level, long_name, name, operation, prec, scale_factor, standard_name, unit  &
-    , valid_max, valid_min )
+    ( field_id, add_offset, axis_ref, default_value, detect_missing_value, domain_ref, enabled, field_ref  &
+    , freq_offset, freq_op, grid_ref, level, long_name, name, operation, prec, scale_factor, standard_name  &
+    , unit, valid_max, valid_min )
     
     IMPLICIT NONE
@@ -203,4 +214,6 @@
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: axis_ref
       REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: default_value
+      LOGICAL  , OPTIONAL, INTENT(OUT) :: detect_missing_value
+      LOGICAL (KIND=C_BOOL) :: detect_missing_value_tmp
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: domain_ref
       LOGICAL  , OPTIONAL, INTENT(OUT) :: enabled
@@ -223,14 +236,14 @@
       CALL xios(get_field_handle)(field_id,field_hdl)
       CALL xios(get_field_attr_hdl_)   &
-      ( field_hdl, add_offset, axis_ref, default_value, domain_ref, enabled, field_ref, freq_offset  &
-      , freq_op, grid_ref, level, long_name, name, operation, prec, scale_factor, standard_name, unit  &
-      , valid_max, valid_min )
+      ( field_hdl, add_offset, axis_ref, default_value, detect_missing_value, domain_ref, enabled  &
+      , field_ref, freq_offset, freq_op, grid_ref, level, long_name, name, operation, prec, scale_factor  &
+      , standard_name, unit, valid_max, valid_min )
     
   END SUBROUTINE xios(get_field_attr)
   
   SUBROUTINE xios(get_field_attr_hdl)  &
-    ( field_hdl, add_offset, axis_ref, default_value, domain_ref, enabled, field_ref, freq_offset  &
-    , freq_op, grid_ref, level, long_name, name, operation, prec, scale_factor, standard_name, unit  &
-    , valid_max, valid_min )
+    ( field_hdl, add_offset, axis_ref, default_value, detect_missing_value, domain_ref, enabled  &
+    , field_ref, freq_offset, freq_op, grid_ref, level, long_name, name, operation, prec, scale_factor  &
+    , standard_name, unit, valid_max, valid_min )
     
     IMPLICIT NONE
@@ -239,4 +252,6 @@
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: axis_ref
       REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: default_value
+      LOGICAL  , OPTIONAL, INTENT(OUT) :: detect_missing_value
+      LOGICAL (KIND=C_BOOL) :: detect_missing_value_tmp
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: domain_ref
       LOGICAL  , OPTIONAL, INTENT(OUT) :: enabled
@@ -258,14 +273,14 @@
       
       CALL xios(get_field_attr_hdl_)  &
-      ( field_hdl, add_offset, axis_ref, default_value, domain_ref, enabled, field_ref, freq_offset  &
-      , freq_op, grid_ref, level, long_name, name, operation, prec, scale_factor, standard_name, unit  &
-      , valid_max, valid_min )
+      ( field_hdl, add_offset, axis_ref, default_value, detect_missing_value, domain_ref, enabled  &
+      , field_ref, freq_offset, freq_op, grid_ref, level, long_name, name, operation, prec, scale_factor  &
+      , standard_name, unit, valid_max, valid_min )
     
   END SUBROUTINE xios(get_field_attr_hdl)
   
   SUBROUTINE xios(get_field_attr_hdl_)   &
-    ( field_hdl, add_offset_, axis_ref_, default_value_, domain_ref_, enabled_, field_ref_, freq_offset_  &
-    , freq_op_, grid_ref_, level_, long_name_, name_, operation_, prec_, scale_factor_, standard_name_  &
-    , unit_, valid_max_, valid_min_ )
+    ( field_hdl, add_offset_, axis_ref_, default_value_, detect_missing_value_, domain_ref_, enabled_  &
+    , field_ref_, freq_offset_, freq_op_, grid_ref_, level_, long_name_, name_, operation_, prec_  &
+    , scale_factor_, standard_name_, unit_, valid_max_, valid_min_ )
     
     IMPLICIT NONE
@@ -274,4 +289,6 @@
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: axis_ref_
       REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: default_value_
+      LOGICAL  , OPTIONAL, INTENT(OUT) :: detect_missing_value_
+      LOGICAL (KIND=C_BOOL) :: detect_missing_value__tmp
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: domain_ref_
       LOGICAL  , OPTIONAL, INTENT(OUT) :: enabled_
@@ -304,4 +321,9 @@
       ENDIF
       
+      IF (PRESENT(detect_missing_value_)) THEN
+        CALL cxios_get_field_detect_missing_value(field_hdl%daddr, detect_missing_value__tmp)
+        detect_missing_value_=detect_missing_value__tmp
+      ENDIF
+      
       IF (PRESENT(domain_ref_)) THEN
         CALL cxios_get_field_domain_ref(field_hdl%daddr, domain_ref_, len(domain_ref_))
@@ -374,7 +396,7 @@
   
   SUBROUTINE xios(is_defined_field_attr)  &
-    ( field_id, add_offset, axis_ref, default_value, domain_ref, enabled, field_ref, freq_offset  &
-    , freq_op, grid_ref, level, long_name, name, operation, prec, scale_factor, standard_name, unit  &
-    , valid_max, valid_min )
+    ( field_id, add_offset, axis_ref, default_value, detect_missing_value, domain_ref, enabled, field_ref  &
+    , freq_offset, freq_op, grid_ref, level, long_name, name, operation, prec, scale_factor, standard_name  &
+    , unit, valid_max, valid_min )
     
     IMPLICIT NONE
@@ -387,4 +409,6 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: default_value
       LOGICAL(KIND=C_BOOL) :: default_value_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: detect_missing_value
+      LOGICAL(KIND=C_BOOL) :: detect_missing_value_tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: domain_ref
       LOGICAL(KIND=C_BOOL) :: domain_ref_tmp
@@ -422,14 +446,14 @@
       CALL xios(get_field_handle)(field_id,field_hdl)
       CALL xios(is_defined_field_attr_hdl_)   &
-      ( field_hdl, add_offset, axis_ref, default_value, domain_ref, enabled, field_ref, freq_offset  &
-      , freq_op, grid_ref, level, long_name, name, operation, prec, scale_factor, standard_name, unit  &
-      , valid_max, valid_min )
+      ( field_hdl, add_offset, axis_ref, default_value, detect_missing_value, domain_ref, enabled  &
+      , field_ref, freq_offset, freq_op, grid_ref, level, long_name, name, operation, prec, scale_factor  &
+      , standard_name, unit, valid_max, valid_min )
     
   END SUBROUTINE xios(is_defined_field_attr)
   
   SUBROUTINE xios(is_defined_field_attr_hdl)  &
-    ( field_hdl, add_offset, axis_ref, default_value, domain_ref, enabled, field_ref, freq_offset  &
-    , freq_op, grid_ref, level, long_name, name, operation, prec, scale_factor, standard_name, unit  &
-    , valid_max, valid_min )
+    ( field_hdl, add_offset, axis_ref, default_value, detect_missing_value, domain_ref, enabled  &
+    , field_ref, freq_offset, freq_op, grid_ref, level, long_name, name, operation, prec, scale_factor  &
+    , standard_name, unit, valid_max, valid_min )
     
     IMPLICIT NONE
@@ -441,4 +465,6 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: default_value
       LOGICAL(KIND=C_BOOL) :: default_value_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: detect_missing_value
+      LOGICAL(KIND=C_BOOL) :: detect_missing_value_tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: domain_ref
       LOGICAL(KIND=C_BOOL) :: domain_ref_tmp
@@ -475,14 +501,14 @@
       
       CALL xios(is_defined_field_attr_hdl_)  &
-      ( field_hdl, add_offset, axis_ref, default_value, domain_ref, enabled, field_ref, freq_offset  &
-      , freq_op, grid_ref, level, long_name, name, operation, prec, scale_factor, standard_name, unit  &
-      , valid_max, valid_min )
+      ( field_hdl, add_offset, axis_ref, default_value, detect_missing_value, domain_ref, enabled  &
+      , field_ref, freq_offset, freq_op, grid_ref, level, long_name, name, operation, prec, scale_factor  &
+      , standard_name, unit, valid_max, valid_min )
     
   END SUBROUTINE xios(is_defined_field_attr_hdl)
   
   SUBROUTINE xios(is_defined_field_attr_hdl_)   &
-    ( field_hdl, add_offset_, axis_ref_, default_value_, domain_ref_, enabled_, field_ref_, freq_offset_  &
-    , freq_op_, grid_ref_, level_, long_name_, name_, operation_, prec_, scale_factor_, standard_name_  &
-    , unit_, valid_max_, valid_min_ )
+    ( field_hdl, add_offset_, axis_ref_, default_value_, detect_missing_value_, domain_ref_, enabled_  &
+    , field_ref_, freq_offset_, freq_op_, grid_ref_, level_, long_name_, name_, operation_, prec_  &
+    , scale_factor_, standard_name_, unit_, valid_max_, valid_min_ )
     
     IMPLICIT NONE
@@ -494,4 +520,6 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: default_value_
       LOGICAL(KIND=C_BOOL) :: default_value__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: detect_missing_value_
+      LOGICAL(KIND=C_BOOL) :: detect_missing_value__tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: domain_ref_
       LOGICAL(KIND=C_BOOL) :: domain_ref__tmp
@@ -542,4 +570,9 @@
       ENDIF
       
+      IF (PRESENT(detect_missing_value_)) THEN
+        detect_missing_value__tmp=cxios_is_defined_field_detect_missing_value(field_hdl%daddr)
+        detect_missing_value_=detect_missing_value__tmp
+      ENDIF
+      
       IF (PRESENT(domain_ref_)) THEN
         domain_ref__tmp=cxios_is_defined_field_domain_ref(field_hdl%daddr)
